
.include "m128def.inc"



.equ BAUD1 = 19200
.equ clock = 14745600 ;






.def BUFFER	=	r25			




.def temp	=	r16
.def temp1  =	r17
.def ADRESSE =	r18




.cseg
.org 0x000                ;  Reset- und Interrupt-Vektoren AT-Mega 128
 jmp reset               ;  Reset Handler
  jmp nix;jmp EXT_INT0    ; IRQ0 Handler
  jmp nix;jmp EXT_INT1    ; IRQ1 Handler
  jmp nix;jmp EXT_INT2    ; IRQ2 Handler
  jmp nix;jmp EXT_INT3    ; IRQ3 Handler
  jmp nix;jmp EXT_INT4    ; IRQ4 Handler
  jmp nix;jmp EXT_INT5    ; IRQ5 Handler
  jmp nix;jmp EXT_INT6    ; IRQ6 Handler
  jmp nix;jmp EXT_INT7    ; IRQ7 Handler
  jmp nix;jmp TIM2_COMP   ; Timer2 Compare Handler
  jmp nix;jmp  TIM2_OVF    ; Timer2 Overflow Handler
  jmp nix;jmp TIM1_CAPT   ; Timer1 Capture Handler
  jmp nix;jmp TIM1_COMPA          ; Timer1 CompareA Handler       **********UHR
  jmp nix;jmp TIM1_COMPB  ; Timer1 CompareB Handler
  jmp nix;jmp TIM1_OVF            ; Timer1 Overflow Handler nix;jmp 
  jmp nix;jmp TIM0_COMP   ; Timer0 Compare Handler
  jmp nix;jmp TIM0_OVF            ; Timer0 Overflow Handler
  jmp nix;jmp SPI_STC     ; SPI Transfer Complete Handler **********PWM
  jmp nix;jmp USART0_RXC  ; USART0 RX Complete Handler
  jmp nix;jmp USART0_DRE  ; USART0,UDR Empty Handler
  jmp nix;jmp USART0_TXC  ; USART0 TX Complete Handler
  jmp nix;jmp ADCINT         ; ADC Conversion Complete Handler
  jmp nix;jmp EE_RDY      ; EEPROM Ready Handler
  jmp nix;jmp ANA_COMP    ; Analog Comparator Handler
  jmp nix;jmp TIM1_COMPC  ; Timer1 CompareC Handler
  jmp nix;jmp TIM3_CAPT   ; Timer3 Capture Handler
  jmp nix;jmp TIM3_COMPA  ; Timer3 CompareA Handler
  jmp nix;jmp TIM3_COMPB  ; Timer3 CompareB Handler
  jmp nix;jmp TIM3_COMPC  ; Timer3 CompareC Handler
  jmp nix;jmp TIM3_OVF    ; Timer3 Overflow Handler
  jmp nix;jmp  USART1_RXC  ; USART1 RX Complete Handlernix;
  jmp nix;jmp USART1_DRE  ; USART1,UDR Empty Handler
  jmp nix;jmp USART1_TXC  ; USART1 TX Complete Handler
  jmp nix;jmp TWI         ; Two-wire Serial Interface Interrupt
nix: reti






reset:



ldi temp, LOW(RAMEND)  ;LOW-Byte der obersten RAM-Adresse
out SPL, temp
ldi temp, HIGH(RAMEND) ;HIGH-Byte der obersten RAM-Adresse
out SPH, temp



    ldi	temp,high((clock/(16*baud1))-1)  ;RS232-1 auf 9600 Baud
	sts	ubrr1l,temp		;Baudratenwert L setzen
	ldi	temp,low((clock/(16*baud1))-1) ;einstellen
	sts	ubrr1h,temp		;Baudratenwert H setzen

    ldi	temp,(9<<ucsz00) ;Datenformat 9N1;
  	sts	ucsr1c,temp		;Datenformat setzen

	ldi	temp,(1<<TXEN1) ;TX mit aktivieren
	sts	ucsr1b,temp		;Einstellungen setzen



LDI ADRESSE,168


;******************************************************************************
;			Hauptschleife
;******************************************************************************

main:

ldi temp1,1
rcall usart_tx1

ldi temp1,2
rcall usart_tx1

rjmp main







USART_TX1:

lds buffer,  UCSR1A
 sbrs buffer, UDRE1
 rjmp USART_TX1
; sts UDR1, temp1   


		

            lds TEMP, UCSR1B      
            Cbr TEMP,1<<TXB81
            sts UCSR1B,TEMP

sts UDR1, adresse   

            lds TEMP, UCSR1B      ; Normalmode einstellen
            Sbr TEMP,1<<TXB81
            sts UCSR1B,TEMP

 


Ausgabe2:
lds buffer,  UCSR1A
sbrs buffer, UDRE1
rjmp Ausgabe2
sts UDR1, temp1   





ret




